/**
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.tests;

import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.testing.InjectWith;
import org.eclipse.xtext.testing.extensions.InjectionExtension;
import org.eclipse.xtext.testing.util.ParseHelper;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.xtext.example.mydsl.scheme.Model;
import org.xtext.example.mydsl.tests.SchemeInjectorProvider;

@ExtendWith(InjectionExtension.class)
@InjectWith(SchemeInjectorProvider.class)
@SuppressWarnings("all")
public class SchemeParsingTest {
  @Inject
  private ParseHelper<Model> parseHelper;
  
  @Test
  public void ModelTest() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("666");
      _builder.newLine();
      final Model result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      System.out.println(result.eResource().getErrors());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void DefineTest() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("(define number 3) ");
      _builder.newLine();
      final Model result = this.parseHelper.parse(_builder);
      System.out.println(result.eResource().getErrors());
      Assertions.assertNotNull(result);
      Assertions.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void DefineTest2() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("(define aws_access_key AGIAJQARMD67CE3DTKHA) ");
      _builder.newLine();
      final Model result = this.parseHelper.parse(_builder);
      System.out.println(result.eResource().getErrors());
      Assertions.assertNotNull(result);
      Assertions.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void LambdaTest() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("( lambda (email) ) ");
      _builder.newLine();
      final Model result = this.parseHelper.parse(_builder);
      System.out.println(result.eResource().getErrors());
      Assertions.assertNotNull(result);
      Assertions.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void OperationTest() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("(- n 1)");
      _builder.newLine();
      final Model result = this.parseHelper.parse(_builder);
      System.out.println(result.eResource().getErrors());
      Assertions.assertNotNull(result);
      Assertions.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void IfTest() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("( if (= (+ 2 3)) (+ 2 3) (- 2 3) )");
      _builder.newLine();
      final Model truthy = this.parseHelper.parse(_builder);
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("( if (= false true) true false )");
      _builder_1.newLine();
      final Model falsy = this.parseHelper.parse(_builder_1);
      System.out.println(truthy.eResource().getErrors());
      System.out.println(falsy.eResource().getErrors());
      Assertions.assertNotNull(truthy);
      Assertions.assertNotNull(falsy);
      Assertions.assertTrue(truthy.eResource().getErrors().isEmpty());
      Assertions.assertTrue(falsy.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
